/* program for Perpetual Calendar 1700 - 2108 A.D. */

#include <stdio.h>

/* names of months for printouts */

char *months[12] =
     {
      "January",
      "February",
      "March",
      "April",
      "May",
      "June",
      "July",
      "August",
      "September",
      "October",
      "November",
      "December"
     };


/* key to day of week month starts on keys to days above also */

enum DAY {
           SUN = 0, MON, TUE, WED, THU, FRI, SAT
         };

/* structure containing day of week month starts with and
   number of days per month */

typedef struct
        {
         enum DAY start_day;
         short    no_days;
        } MONTHSTR;


/* indexes to table below */

enum SEL {
           A = 0, B, C, D, E, F, G, H,
                  I, J, K, L, M, N
          };

/* perp_cal[lookup[year-1700]][month] contains .start_day of week, and
   .no_days per month */

MONTHSTR perp_cal[14][12] =
         {
          { WED, 31, SAT, 28, SAT, 31, TUE, 30, THU, 31, SUN, 30,
            TUE, 31, FRI, 31, MON, 30, WED, 31, SAT, 30, MON, 31 },
          { THU, 31, SUN, 28, SUN, 31, WED, 30, FRI, 31, MON, 30,
            WED, 31, SAT, 31, TUE, 30, THU, 31, SUN, 30, TUE, 31 },
          { FRI, 31, MON, 29, TUE, 31, FRI, 30, SUN, 31, WED, 30,
            FRI, 31, MON, 31, THU, 30, SAT, 31, TUE, 30, THU, 31 },
          { SUN, 31, THU, 28, WED, 31, SAT, 30, MON, 31, THU, 30,
            SAT, 31, TUE, 31, FRI, 30, SUN, 31, WED, 30, FRI, 31 },
          { MON, 31, THU, 28, THU, 31, SUN, 30, TUE, 31, FRI, 30,
            SUN, 31, WED, 31, SAT, 30, MON, 31, THU, 30, SAT, 31 },
          { TUE, 31, FRI, 28, FRI, 31, MON, 30, WED, 31, SAT, 30,
            MON, 31, THU, 31, SUN, 30, TUE, 31, FRI, 30, SUN, 31 },
          { WED, 31, SAT, 29, SUN, 31, WED, 30, FRI, 31, MON, 30,
            WED, 31, SAT, 31, SUN, 30, THU, 31, SUN, 30, TUE, 31 },
          { FRI, 31, MON, 28, MON, 31, THU, 30, SAT, 31, TUE, 30,
            THU, 31, SUN, 31, WED, 30, FRI, 31, MON, 30, WED, 31 },
          { SAT, 31, TUE, 28, TUE, 31, FRI, 30, SUN, 31, WED, 30,
            FRI, 31, MON, 31, THU, 30, SAT, 31, TUE, 30, THU, 31 },
          { MON, 31, THU, 29, FRI, 31, MON, 30, WED, 31, SAT, 30,
            MON, 31, THU, 31, SUN, 30, TUE, 31, FRI, 30, SUN, 31 },
          { SAT, 31, TUE, 29, WED, 31, SAT, 30, MON, 31, THU, 30,
            SAT, 31, TUE, 31, FRI, 30, SUN, 31, WED, 30, FRI, 31 },
          { SUN, 31, WED, 29, THU, 31, SUN, 30, TUE, 31, FRI, 30,
            SUN, 31, WED, 31, SAT, 30, MON, 31, THU, 30, SAT, 31 },
          { TUE, 31, FRI, 29, SAT, 31, TUE, 30, THU, 31, SUN, 30,
            TUE, 31, FRI, 31, MON, 30, WED, 31, SAT, 30, MON, 31 },
          { THU, 31, SUN, 29, MON, 31, THU, 30, SAT, 31, TUE, 30,
            THU, 31, MON, 31, WED, 30, FRI, 31, MON, 30, WED, 31 }
          };

/* index to table above */

enum SEL lookup[] =
     {
      H, I, D, E, M, B, H, I, L, F, A, B, C, D,
      E, F, G, H, I, D, J, A, B, H, K, E, F, A,
      N, I, D, E, M, B, H, I, L, F, A, B, C, D,
      E, F, G, H, I, D, J, A, B, H, K, E, F, A,
      N, I, D, E, M, B, H, I, L, F, A, B, C, D,
      E, F, G, H, I, D, J, A, B, H, K, E, F, A,
      N, I, D, E, M, B, H, I, L, F, A, B, C, D,
      E, F, A, B, H, I, L, F, A, B, C, D, E, F,
      G, H, I, D, J, A, B, H, K, E, F, A, N, I,
      D, E, M, B, H, I, L, F, A, B, C, D, E, F,
      G, H, I, D, J, A, B, H, K, E, F, A, N, I,
      D, E, M, B, H, I, L, F, A, B, C, D, E, F,
      G, H, I, D, J, A, B, H, K, E, F, A, N, I,
      D, E, M, B, H, I, L, F, A, B, C, D, E, F,
      G, H, I, D, E, F, A, B, C, D, E, F, G, H,
      I, D, J, A, B, H, K, E, F, A, N, I, D, E,
      M, B, H, I, L, F, A, B, C, D, E, F, G, H,
      I, D, J, A, B, H, K, E, F, A, N, I, D, E,
      M, B, H, I, L, F, A, B, C, D, E, F, G, H,
      I, D, J, A, B, H, K, E, F, A, N, I, D, E,
      M, B, H, I, L, F, A, B, C, D, E, F, G, H,
      I, D, J, A, B, H, K, E, F, A, N, I, D, E,
      M, B, H, I, L, F, A, B, C, D, E, F, G, H,
      I, D, J, A, B, H, K, E, F, A, N, I, D, E,
      M, B, H, I, L, F, A, B, C, D, E, F, G, H,
      I, D, J, A, B, H, K, E, F, A, N, I, D, E,
      M, B, H, I, L, F, A, B, C, D, E, F, G, H,
      I, D, J, A, B, H, K, E, F, A, N, I, D, E,
      M, B, H, I, L, F, A, B, H, I, D, E, M, B,
      H, I, L
     };

/* data structure used to cart data to and from routines */

typedef struct
        {
         short month;
         short year;
         short day;
         short day_of_week;
         enum DAY start_day;
         short no_days;
        } DAT;

DAT work_data, end_data;

short offset = 0, pause = 0;

enum COM { DEF = 0, GIVEN, RANGE } command;

/* char arrays used for printing out calendar */
char htop[55] = { "\n \xc9\xcd\xcd\xcd\xcd\xcd\xcd\xcb\xcd\xcd\xcd\xcd\
\xcd\xcd\xcb\xcd\xcd\xcd\xcd\xcd\xcd\xcb\xcd\xcd\xcd\xcd\
\xcd\xcd\xcb\xcd\xcd\xcd\xcd\xcd\xcd\xcb\xcd\xcd\xcd\xcd\xcd\
\xcd\xcb\xcd\xcd\xcd\xcd\xcd\xcd\xbb\n"  };

char head[55] = { " \xba SUN. \xba MON. \xba TUE. \xba WED. \xba THU. \xba FRI. \xba SAT. \xba \n" };

char tail[55] = { " \xc8\xcd\xcd\xcd\xcd\xcd\xcd\xca\xcd\xcd\xcd\xcd\xcd\xcd\
\xca\xcd\xcd\xcd\xcd\xcd\xcd\xca\xcd\xcd\xcd\xcd\xcd\xcd\xca\
\xcd\xcd\xcd\xcd\xcd\xcd\xca\xcd\xcd\xcd\xcd\xcd\xcd\xca\
\xcd\xcd\xcd\xcd\xcd\xcd\xbc \n\n" };

char seps[55] = { " \xcc\xcd\xcd\xcd\xcd\xcd\xcd\xce\xcd\xcd\xcd\xcd\xcd\xcd\
\xce\xcd\xcd\xcd\xcd\xcd\xcd\xce\xcd\xcd\xcd\xcd\xcd\xcd\
\xce\xcd\xcd\xcd\xcd\xcd\xcd\xce\xcd\xcd\xcd\xcd\xcd\xcd\
\xce\xcd\xcd\xcd\xcd\xcd\xcd\xb9 \n" };

char cals[5][55] =
   {
     { " \xba      \xba      \xba      \xba      \xba      \xba      \xba      \xba \n" },
     { " \xba      \xba      \xba      \xba      \xba      \xba      \xba      \xba \n"  },
     { " \xba      \xba      \xba      \xba      \xba      \xba      \xba      \xba \n"  },
     { " \xba      \xba      \xba      \xba      \xba      \xba      \xba      \xba \n"  },
     { " \xba      \xba      \xba      \xba      \xba      \xba      \xba      \xba \n"  }
   };
char temp[10];


/* array of positions across */

short col_pos[7] = { 5, 12, 19, 26, 33, 40, 47 };

error_prn( errs, erno )
char *errs;
short erno;
{
 static char err1[45] = { "ILLEGAL OPTION ERROR!!  Error = " };
 static char err2[50] = { "ILLEGAL DATE USED ERROR!!  Error = " };
 static char err3[] = { "ILLEGAL RANGE ERROR!!\n " };

 if ( erno == 1 )
    {
     err1[32] = 0;
     strcat( err1, errs );
     strcat( err1, "\n" );
     fputs( err1, stderr );
    }
 else if ( erno == 2 )
    {
     err2[35] = 0;
     strcat( err2, errs );
     strcat( err2, "\n" );
     fputs( err2, stderr );
    }
 else
    fputs( err3, stderr );

}



/* function to get data from arrays and structures */

get_dat()
{
 short cal_look;

 cal_look = (short) lookup[work_data.year-1700];
 work_data.start_day = perp_cal[cal_look][work_data.month-1].start_day;
 work_data.no_days = perp_cal[cal_look][work_data.month-1].no_days;
}


/* function to make numbers into string right justified in field length
   works with 4 digit numbers and 2 digit positive integers */

char *makestr( str, n, width )
char *str;
unsigned n;
short width;
{
 if ( n > 2108 || ( width != 2 && width != 4 ) || ( width == 2 && n > 99 ) ||
      width == 4 && n < 1000 )
    return( 0 );
 if ( width == 2 && n < 10 )
    {
     *str = ' ';
     *(str+1) = n + 48;
     *(str+2) = 0;
     return( str );
    }
 else if ( width == 2 && n < 99 )
    {
     *str = (n / 10) + 48;
     *(str+1) = (n % 10) + 48;
     *(str+2) = 0;
     return( str );
    }
 else
    {
     *str = (n / 1000) + 48;
     n %= 1000;
     *(str+1) = (n / 100) + 48;
     n %= 100;
     *(str+2) = (n / 10) +48;
     *(str+3) = (n % 10) +48;
     *(str+4) = 0;
     return( str );
    }
}

/* routine to copy string into another string 2 characters width only */

strinp( in, str, pos )
char *in;
char *str;
short pos;
{

 --pos;
 str += pos;
 *str = *in;
 *(str+1) = *(in+1);
 *(str+2) = ' ';
}



/* routine to center calendar header */

char *center( str )
char *str;
{
 int x;

 x = strlen( str );
 memcpy( str+((52-x)/2), str, x+2 );
 memset( str, 32, (52-x)/2 );
 return( str );

}

print_cal()
{
  short x;
  char str[60];

  str[0] = 0;
  strcat( str, "Calendar For: " );
  strcat( str, months[work_data.month-1] );
  if ( work_data.day > 9 )
     strcat( str, " " );
  if ( work_data.day != 0 )
     strcat( str, makestr( temp, work_data.day, 2 ) );
  strcat( str, ", " );
  strcat( str, makestr( temp, work_data.year, 4 ) );
  strcat( str, "\n" );
  fputs( "\n", stdout );
  fputs( center( str ), stdout );
  fputs( htop, stdout );
  fputs( head, stdout );
  fputs( seps, stdout );
  for ( x = 0; x <= 4; ++x )
      {
       fputs( &cals[x][0], stdout );
       if ( x != 4 )
          fputs( seps, stdout );
      }
  fputs( tail, stdout );
  if ( command == RANGE )
     fputs( "\n", stdout );
}



/*
typedef struct
        {
         short month;
         short year;
         short day;
         enum SEL cal_look;
         enum DAY start_day;
         short no_days;
        } DAT;
*/


/* function to parse date line entered. Arg separators are - and /. If 3 args
arg 1 is month arg 2 is day and arg 3 is year. If 1 arg, arg 1 is month rest
is default date. If 2 args, first arg is month. If second arg is greater than
31 and less than 1700 then it is taken to be an offset of year 1900 in year
though only offsets up to 208 are allowed. Otherwise 2nd arg is day. If arg
3 is less than 1000 it is taken as an offset off year 1900, though only
offsets of up to 208 are allowed, otherwise it is taken as a year. Not year
must be between 1700 and 2108 returns -1 if an error occurs */

parse_date( dats, datp )
DAT *datp;
char *dats;
{
 char ch;
 short month = 0;
 short day = 0;
 short year = 0;
 register char *fnd = dats;

                /* ====== ARG 1 =========== */
 month = atoi( fnd );             /* get month */
 if ( month > 12 || month < 1 )   /* test for validity */
    return(-1 );                  /* bad use default */
 else
    datp->month = month;          /* use month as month */
                /* ====== ARG 2 =========== */
 while( ( ch = *fnd++ ) != '-' && ch != '/' && ch != 0 );  /* scan for seper */
 if ( *fnd == 0 || ch == 0 )      /* if end of string return */
     return(0);
 day = atoi( fnd );               /* get 2nd arg */
 if ( day < 1 )
    return( -1 );
 else if ( day > 31 )             /* if it's not a valid day number ? a year */
    {
     if ( day > 1700 && day <= 2108 )  /*  valid year ? */
        {
         datp->year = day;              /*  use as year  */
         return( 0 );
        }
     else if ( day < 208 )              /* is valid offset year */
        {
         datp->year = 1900 + day;       /* use as offset */
         return( 0 );
        }
     else
        return( -1 );                   /* error code */
    }
 else
    datp->day = day;                    /* otherwise use as day */
                /* ====== ARG 3 =========== */
 while( ( ch = *fnd++ ) != '-' && ch != '/' && ch != 0 );  /* scan for seper */
 if ( *fnd == 0 || ch == 0 )           /* if end of string return */
     return(0);
 year = atoi( fnd );                   /* get 3rd arg */
 if ( year < 1 )
    return( -1 );
 if ( year > 1700 && year <= 2108 )    /* test for validity */
    datp->year = year;                 /* use as year */
 else if ( year < 208 )                /* is offset */
    datp->year = 1900 + year;          /* use as offset */
 else
    return( -1 );                  /* otherwise return error code */
}


/* routine to offset days by amount desired from start day
   get_dat() must be called first */

offset_date( days )
short days;
{
 short to_go;

 if (( work_data.day += days ) <= work_data.no_days && work_data.day > 0 )
    return;
 else
    {
     if ( work_data.day > 0 )
        to_go = work_data.day - work_data.no_days;
     else
        to_go = work_data.day;
     while ( to_go != 0 )
           {
            if ( to_go > 0 )
               {
                ++work_data.month;
                work_data.day = 0;
                if ( work_data.month > 12 )
                   {
                    ++work_data.year;
                    work_data.month = 1;
                   }
                get_dat();
                if ( work_data.no_days >= to_go )
                   {
                    work_data.day += to_go;
                    to_go = 0;
                   }
                else
                   to_go -= work_data.no_days;
               }
            else
               {
                --work_data.month;
                if ( work_data.month == 0 )
                   {
                    --work_data.year;
                    work_data.month = 12;
                   }
                get_dat();
                work_data.day = work_data.no_days;
                work_data.day += to_go;
                if ( work_data.day > 0 )
                   to_go = 0;
                else if ( work_data.day == 0 )
                   to_go = -1;
                else
                   to_go = work_data.day;
               }
           }
    }
}

/* routine to clear calendar */
clear_cal()
{
 short x, y;

 for ( x = 0; x <= 4; ++x )
     {
      for ( y = 0; y <= 6; ++y )
          strinp( "  ", &cals[x][0], col_pos[y] );
     }
}

make_cal()
{
 short day, lin, nd, pos;


 nd = work_data.no_days;
 lin = 0;
 pos = ( short ) work_data.start_day-1;
 for ( day = 1; day <= nd; ++day )
     {
      ++pos;
      if ( pos > 6 )
         {
          pos = 0;
          ++lin;
         }
      makestr( temp, day, 2 );
      strinp( temp, &cals[lin][0], col_pos[pos]);
     }
}



/* routine to parse command and setup variables for actions returns
   -1 for error occurred */

parse_command( str )
char *str;
{
 char ch = *str;
 short ret;

 if ( ch != '-' && ch != '/' )
    {
     error_prn( str, 1 );
     return( -1 );
    }
 ch = *(str+1);
 if ( ch <= 'z' && ch >= 'a' )
    ch ^= 0x20;
 switch( ch )
       {
        case 'O' :
             offset = atoi( str+2 );
             get_dat();
             offset_date( offset );
             break;
        case 'F' :
             if ( ( ret = parse_date( str+2, &work_data ) ) == -1 )
                {
                 error_prn( str, 2 );
                 return( -1 );
                }
             command = RANGE;
             break;
        case 'T' :
             if ( ( ret = parse_date( str+2, &end_data ) ) == -1 )
                {
                 error_prn( str, 2 );
                 return( -1 );
                }
             command = RANGE;
             break;
        case 'G' :
        case 'D' :
             if ( ( ret = parse_date( str+2, &work_data ) ) == -1 )
                {
                 error_prn( str, 2 );
                 return( -1 );
                }
             command = GIVEN;
             break;
        case 'P' :
             pause = 1;
             break;
        default  :
             error_prn( str, 1 );
             return( -1 );
       }
 return( 0 );
}

main( argc, argv )
short argc;
char *argv[];
{
 short x, not_done, err = 0;

 dos_date( &work_data );
 dos_date( &end_data );
 for ( x = 1; x < argc && !err; ++x )
     parse_command( argv[x] );
 if ( err )
    exit( -1 );
 else if ( command != RANGE )
    {
     if ( !offset )
        get_dat();
     make_cal();
     print_cal();
    }
 else
    {
     if ( work_data.year > end_data.year )
        {
         error_prn( 0, 3 );
         exit( -1 );
        }
     else if ( work_data.year == end_data.year && work_data.month >= end_data.month )
        {
         error_prn( 0, 3 );
         exit( -1 );
        }
     else
        {
         if ( !offset )
            get_dat();
         not_done = ((end_data.year - work_data.year) * 12 )
                + ( end_data.month - work_data.month );
         while ( not_done-- )
               {
                make_cal();
                print_cal();
                clear_cal();
                ++work_data.month;
                if ( work_data.month > 12 )
                   {
                    work_data.month = 1;
                    ++work_data.year;
                   }
                get_dat();
                if ( pause )
                   {
                    fputs( "PRESS ANY KEY... ", stderr );
                    getch();
                    fputs( "\n\n", stderr );
                   }
               }

        }
    }
 exit(0);
}


